const Model = require('flitter-orm/src/model/Model')
const uuid = require('uuid/v4')

/*
 * FileGroup Model
 * -------------------------------------------------------------
 * Put some description here!
 */
class FileGroup extends Model {
    static get schema() {
        // Return a flitter-orm schema here.
        return {
            NodeId: String,
            PageId: String,
            FileIds: [String],
            UUID: {type: String, default: () => uuid()}
        }
    }

    accessible_by(user, mode = 'view') {
        return user.can(`files:${this.UUID}:${mode}`)
    }
    
    // Static and instance methods can go here
}

module.exports = exports = FileGroup
